package esercizio1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.regex.Pattern;

public class GestioneFile {
	public GestioneFile() {
	}

	private String stringaCasuale() {
		String[] alfabeto = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "l", "m", "n", "o", "p", "q", "r", "s", "t",
				"u", "v", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
		Random r = new Random();
		// Almeno un carattere
		int lunghezza = r.nextInt(3) + 1;
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < lunghezza; i++) {
			int indice = r.nextInt(alfabeto.length);
			builder.append(alfabeto[indice]);
		}
		return builder.toString();
	}

	private Integer numeroCasuale() {
		Random r = new Random();
		int n = r.nextInt(100);
		return n;
	}

	public void generaFile(String nomeFile) {
		int numeroElementi = numeroCasuale();
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(nomeFile));
			for (int i = 0; i < numeroElementi; i++) {
				writer.append(stringaCasuale());
				// Non stampiamo il fine linea per l'ultimo elemento
				if (i != numeroElementi - 1)
					writer.newLine();
			}
			writer.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + nomeFile);
		}
	}

	private ArrayList<String> leggi(String nomeFile) {
		ArrayList<String> a = new ArrayList<String>();
		try {
			BufferedReader b = new BufferedReader(new FileReader(nomeFile));
			while (b.ready()) {
				a.add(b.readLine());
			}
			b.close();
		} catch (IOException e) {
			System.out.println("Errore nella gestione del file " + nomeFile);
		}
		return a;
	}
	
	public void stampaLineeNumeriche(String nomeFile) {
		ArrayList<String> elementi = leggi(nomeFile);
		for(String s : elementi) {
			if(Pattern.matches("\\d+", s))
				System.out.println(s);
		}
	}
	
	public void stampaLineeConNumero(String nomeFile) {
		ArrayList<String> elementi = leggi(nomeFile);
		for(String s : elementi) {
			if(Pattern.matches("\\d+.*", s))
				System.out.println(s);
		}
	}
	
	public void stampaLineeConLetterePari(String nomeFile, char lettera) {
		ArrayList<String> elementi = leggi(nomeFile);
		for(String s : elementi) {
			if(Pattern.matches("("+lettera+lettera+")+", s))
				System.out.println(s);
		}
	}
	
	public void stampaLineeConNumeroUguale(String nomeFile, char lettera1, char lettera2) {
		ArrayList<String> elementi = leggi(nomeFile);
		for(String s : elementi) {
			int contL1 = 0;
			int contL2 = 0;
			for(int i = 0; i < s.length(); i++) {
				if(s.charAt(i) == lettera1)
					contL1++;
				if(s.charAt(i) == lettera2)
					contL2++;
			}
			//Stampa anche le linee che non contengono né lettera 1 e né lettera 2
			if(contL1==contL2)
				System.out.println(s);
		}
	} 
	
	public static void main(String[] args) {
		GestioneFile g = new GestioneFile();
//		g.generaFile("test.txt");
		g.stampaLineeNumeriche("test.txt");
		g.stampaLineeConNumero("test.txt");
		g.stampaLineeConLetterePari("test.txt", 'a');
		g.stampaLineeConNumeroUguale("test.txt", 'a', 'b');
	}
}
