package esercizio2;

import java.util.ArrayList;

public class Ordine {

	private static int numeroOrdini = 0;
	private int id;
	private String nomeCliente;
	private ArrayList<Prodotto> prodotti;
	private Double prezzoTotale;
	
	public Ordine(String nomeCliente) {
		this.nomeCliente = nomeCliente;
		id = numeroOrdini++;
		prodotti = new ArrayList<Prodotto>();
		prezzoTotale = 0.0;
	}
	
	public Double getPrezzoTotale() {
		return prezzoTotale;
	}
	
	public void inserisciProdotto(Prodotto p) {
		prodotti.add(p);
		prezzoTotale += p.getPrezzo();
	}
	
	public String getNomeCliente() {
		return nomeCliente;
	}
	
	public String getId() {
		return ""+id;
	}
	
	@Override
	public String toString() {
		String s = "Ordine n°: " + id + "\n";
		s += "Cliente: " + nomeCliente + "\n";
		s += "Prodotti:\n";
		for(Prodotto p : prodotti) {
			 s += p.toString() + "\n";
		}
		s += "Totale: " + getPrezzoTotale() + " euro";
		return s;
	}
	
	
}
