package esercizio2;

import java.util.HashMap;

import javax.swing.JOptionPane;

public class Ristorante {

	private HashMap<String, Ordine> ordini;
	private HashMap<String, Prodotto> prodotti;

	public Ristorante() {
		ordini = new HashMap<String, Ordine>();
		prodotti = new HashMap<String, Prodotto>();
		prodotti.put("1", new Prodotto("1","Pizza Margherita", 4.0));
		prodotti.put("2", new Prodotto("2","Pizza Capricciosa", 6.5));
		prodotti.put("3", new Prodotto("3","Pizza Quattro Stagioni", 5.5));
		prodotti.put("4", new Prodotto("4","Pizza Marinara", 3.0));
		prodotti.put("5", new Prodotto("5","Pizza Primavera", 6.0));
	}

	private String azioniPossibili() {
		String azioni = "Scegli l'azione da eseguire:\n" + "1 Inserisci ordine\n" + "2 Rimuovi ordine\n"
				+ "3 Mostra ordine\n" + "4 Mostra ordini di un cliente\n" + "5 Termina\n";
		return azioni;
	}	

	public void scegliAzione() {
		while (true) {
			String azione = JOptionPane.showInputDialog(azioniPossibili());
			if(azione==null) //se l'utente chiude la finestra senza inserire una scelta
				break;			
			switch (azione) {
			case "1":
				inserisciOrdine();
				break;
			case "2":
				rimuoviOrdine();
				break;
			case "3":
				mostraOrdine();
				break;
			case "4":
				mostraOrdineCliente();
				break;
			case "5":
				return;
			default:
				JOptionPane.showMessageDialog(null, "Scelta non valida", "Errore", JOptionPane.ERROR_MESSAGE);
				break;
			}
		}
	}

	private String mostraProdotti() {
		StringBuilder s = new StringBuilder();
		for(String prodotto : prodotti.keySet()) {
			s.append(prodotti.get(prodotto).toString());
			s.append("\n");
		}
		return s.toString();
	}

	private void inserisciOrdine() {
		String nomeCliente = JOptionPane.showInputDialog("Inserisci il nome del cliente");
		Ordine o = new Ordine(nomeCliente);
		while (true) {
			String idProdotto = JOptionPane.showInputDialog("Inserisci l'id del prodotto:\n" + mostraProdotti());
			if (prodotti.containsKey(idProdotto)) {
				o.inserisciProdotto(prodotti.get(idProdotto));
			} else {
				JOptionPane.showMessageDialog(null, "Prodotto non presente!", "Errore", JOptionPane.ERROR_MESSAGE);
			}
			int scelta = JOptionPane.showConfirmDialog(null, "Vuoi inserire un altro id?");
			if (scelta != JOptionPane.YES_OPTION)
				break;
		}
		ordini.put(o.getId(), o);
		JOptionPane.showMessageDialog(null, "Ordine effettuato con successo. Riepilogo:\n" + o.toString());
	}

	private void rimuoviOrdine() {
		String idOrdine = JOptionPane.showInputDialog("Inserisci l'id dell'ordine da eliminare");
		if (ordini.containsKey(idOrdine)) {
			ordini.remove(idOrdine);
		} else {
			JOptionPane.showMessageDialog(null, "Ordine non presente!", "Errore", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void mostraOrdine() {
		String id = JOptionPane.showInputDialog("Inserisci l'id dell'ordine da mostrare");
		if (ordini.containsKey(id))
			JOptionPane.showMessageDialog(null, ordini.get(id).toString());
		else
			JOptionPane.showMessageDialog(null, "Ordine non trovato");

	}

	private void mostraOrdineCliente() {
		String nomeCliente = JOptionPane.showInputDialog("Inserisci il nome del cliente");
		StringBuilder builder = new StringBuilder();
		for(String o : ordini.keySet()) {
			if(nomeCliente.equals(ordini.get(o).getNomeCliente())) {
				builder.append(ordini.get(o).toString()+"\n");
			}
		}
		JOptionPane.showMessageDialog(null, "Ordini del cliente " + nomeCliente + "\n" + builder.toString());		
	}

	public static void main(String[] args) {
		Ristorante r = new Ristorante();
		r.scegliAzione();
	}

}
